package com.segment.analyticsreactnativepluginsignals

import com.facebook.react.bridge.Callback
import com.facebook.react.bridge.LifecycleEventListener
import com.facebook.react.bridge.ReactApplicationContext
import com.facebook.react.bridge.ReactContextBaseJavaModule
import com.facebook.react.bridge.ReactMethod
import com.facebook.react.bridge.WritableMap
import com.facebook.react.module.annotations.ReactModule


@ReactModule(name="AnalyticsReactNativePluginSignals")
class AnalyticsReactNativePluginSignalsModule(
  private val reactContext: ReactApplicationContext
) : ReactContextBaseJavaModule(reactContext), LifecycleEventListener {

  val plugin = SignalsUIToolkitTrackingPlugin(this::emit)

  var callback: Callback? = null

  init {
    reactContext.addLifecycleEventListener(this)
  }

  override fun getName(): String {
    return NAME
  }

  @ReactMethod
  fun addListener(type: String?) {
    // Keep: Required for RN built in Event Emitter Calls.
  }

  @ReactMethod
  fun removeListeners(type: Int) {
    // Keep: Required for RN built in Event Emitter Calls.
  }

  @ReactMethod
  fun setupEmitCallback(callback: Callback) {
    this.callback = callback
  }

  fun emit(event: String, params: WritableMap) {
    callback?.invoke(event, params)
  }

  companion object {
    const val NAME = "AnalyticsReactNativePluginSignals"
  }

  override fun onHostResume() {
    plugin.autoTracking(reactContext)
  }

  override fun onHostPause() {

  }

  override fun onHostDestroy() {

  }
}
