"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.signalsScreenTracking = void 0;
var _signals = require("../signals");
var _types = require("../types");
const signalsScreenTracking = exports.signalsScreenTracking = {
  screenStack: [],
  currentScreen: undefined,
  onScreenChange: function (screen) {
    if (this.screenStack.length > 0 && this.screenStack[this.screenStack.length - 1] == screen) {
      _signals.Signals.emit(new _types.Navigation.Signal(_types.Navigation.Action.Backward, screen ?? "Unknown"));
      this.screenStack.pop();
      this.currentScreen = screen;
    } else {
      _signals.Signals.emit(new _types.Navigation.Signal(_types.Navigation.Action.Forward, screen ?? "Unknown"));
      this.screenStack.push(this.currentScreen);
      this.currentScreen = screen;
    }
  }
};
//# sourceMappingURL=signals-screen-tracking.js.map