"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SignalsUITracking = void 0;
var _analyticsReactNative = require("@segment/analytics-react-native");
var _reactNative = require("react-native");
var _signals = require("../signals");
var _types = require("../types");
const {
  AnalyticsReactNativePluginSignals
} = _reactNative.NativeModules;
class SignalsUITracking extends _analyticsReactNative.UtilityPlugin {
  type = _analyticsReactNative.PluginType.utility;
  callback = (event, params) => {
    if (event == 'InteractionSignal') {
      _signals.Signals.emit(new _types.Interaction.Signal(params.component, params.title));
    }
    AnalyticsReactNativePluginSignals.setupEmitCallback(this.callback);
  };
  configure(analytics) {
    super.configure(analytics);
    AnalyticsReactNativePluginSignals.setupEmitCallback(this.callback);
  }
}
exports.SignalsUITracking = SignalsUITracking;
//# sourceMappingURL=signals-ui-tracking.js.map