import { Plugin, PluginType, SegmentClient, SegmentEvent } from "@segment/analytics-react-native";
import { Config, RawSignal } from "./types";
import { SignalsJS } from "./compat";
import { LivePluginDependent } from "@segment/analytics-react-native-plugin-live";
import { SegmentClientLivePluginLayer } from "@segment/analytics-react-native-plugin-live";
export declare class SignalsPlugin extends Plugin implements LivePluginDependent {
    type: PluginType;
    private _config;
    set config(value: Config);
    get broadcasters(): import("./types").SignalBroadcaster[];
    private _queuedSignals;
    private _ready;
    private _counter;
    private _timerStarted;
    private _timer;
    private _signals;
    private _compatLayer?;
    private _runtime;
    get runtime(): {};
    get anonymousId(): string;
    get nextIndex(): number;
    get buffer(): RawSignal<any>[];
    get jsSignals(): SignalsJS;
    private static _instance;
    private constructor();
    prepare(compatLayer: SegmentClientLivePluginLayer): void;
    readyToStart(): void;
    static get instance(): SignalsPlugin;
    configure(analytics: SegmentClient): void;
    execute(event: SegmentEvent): SegmentEvent | undefined;
    emit<T>(signal: RawSignal<T>): void;
    replayQueuedSignals(): void;
    updateJSConfiguration(): void;
    updateNativeConfiguration(): void;
    private schedule;
    private unschedule;
}
export declare const Signals: SignalsPlugin;
//# sourceMappingURL=signals.d.ts.map