import { Signals } from "../signals";
import { Navigation } from "../types";

export type SignalsScreenTracking = {
  screenStack: (string | undefined)[];

  currentScreen?: string;

  onScreenChange: (screen?: string) => void;
}

export const signalsScreenTracking: SignalsScreenTracking = {
  screenStack: [],
  currentScreen: undefined,
  onScreenChange: function (screen?: string) {
    if (this.screenStack.length > 0 && this.screenStack[this.screenStack.length - 1] == screen) {
      Signals.emit(new Navigation.Signal(Navigation.Action.Backward, screen ?? "Unknown"));
      this.screenStack.pop();
      this.currentScreen = screen;
    }
    else {
      Signals.emit(new Navigation.Signal(Navigation.Action.Forward, screen ?? "Unknown"));
      this.screenStack.push(this.currentScreen);
      this.currentScreen = screen;
    }
  }
}