import { PluginType, SegmentClient, UtilityPlugin } from "@segment/analytics-react-native";
import { NativeModules } from "react-native";
import { Signals } from "../signals";
import { Interaction } from "../types";

const { AnalyticsReactNativePluginSignals } = NativeModules

export class SignalsUITracking extends UtilityPlugin {

  type = PluginType.utility;

  callback = (event: String, params: any) => {
    if (event == 'InteractionSignal') {
      Signals.emit(new Interaction.Signal(params.component, params.title));
    }
    AnalyticsReactNativePluginSignals.setupEmitCallback(this.callback);
  };

  configure(analytics: SegmentClient): void {
    super.configure(analytics);
    AnalyticsReactNativePluginSignals.setupEmitCallback(this.callback);
  }
}